local playerGUID = UnitGUID("player")

local recentlyFired = false
local windfuryTimestamp = null
local runningDamageAmount = 0
local leastValue = 0
local swingCount = 0

local combn = CreateFrame("Frame")
combn:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
combn:SetScript("OnEvent", function(self, event)
	-- pass a variable number of arguments
	self:OnEvent(event, CombatLogGetCurrentEventInfo())
end)

function combn:OnEvent(event, ...)
	-- gather information here
	local timestamp, subevent, _, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags, test1, buffName = ...
	local spellId, spellName, spellSchool
	local amount, overkill, school, resisted, blocked, absorbed, critical, glancing, crushing, isOffHand

	--print(buffName);
	--print(subevent)
	
	if (buffName == "Terrifying Roar" and destGUID == playerGUID) then
		Stopwatch_StartCountdown(0, 0, 20); 
		Stopwatch_Play()
	end

	if (subevent == "SPELL_DAMAGE" and buffName == "Shadow Burst" and sourceName == "Naxxramas Cultist" and destGUID == playerGUID) then
		PlaySoundFile("Interface\\AddOns\\WFGoWhoosh\\Boing2.wav")
	end

	if (subevent == "UNIT_DIED") then
		if ((string.match(destName, "Quenlil") or string.match(destName, "Tecatelight")) and not UnitIsFeignDeath(destName)) then
			PlaySoundFile("Interface\\AddOns\\WFGoWhoosh\\QuenDeath.wav")
		end
	end

	-- if we have swing damage, check to see if the timestamp is the same as the windfury timestamp
	--if subevent == "SPELL_DAMAGE" and sourceGUID == playerGUID then
	--	amount, overkill, school, resisted, blocked, absorbed, critical, glancing, crushing, isOffHand = select(12, ...)
	--
	--	if timestamp == windfuryTimestamp then
	--		if ((leastValue > amount) and amount ~= 0) or leastValue == 0 then 
	--			leastValue = amount
	--		end
	--
	--		runningDamageAmount = runningDamageAmount + amount
	--		swingCount = swingCount + 1
	--
	--	elseif runningDamageAmount ~= 0 then
	--		-- find the minimum value to skip
	--		if (swingCount == 3) then
	--				GLOBAL_WFGoWhoosh_windfuryDamageAmount = GLOBAL_WFGoWhoosh_windfuryDamageAmount + ((runningDamageAmount  - (leastValue)))
	--		elseif (swingCount == 2) then
	--			if (string.match(buffName, "Totem")) then
	--				GLOBAL_WFGoWhoosh_windfuryDamageAmount = GLOBAL_WFGoWhoosh_windfuryDamageAmount + ((runningDamageAmount  - (leastValue)))
	--			else -- windfury imbue
	--				GLOBAL_WFGoWhoosh_windfuryDamageAmount = GLOBAL_WFGoWhoosh_windfuryDamageAmount + runningDamageAmount
	--			end
	--		else
	--			GLOBAL_WFGoWhoosh_windfuryDamageAmount = GLOBAL_WFGoWhoosh_windfuryDamageAmount + runningDamageAmount
	--		end
	--		
	--	--	print("windfury Amount: " .. GLOBAL_WFGoWhoosh_windfuryDamageAmount)
	--		runningDamageAmount = 0
	--		leastValue = 0
	--	end
	--
	--	GLOBAL_WFGoWhoosh_totalMeleeDamageDone = GLOBAL_WFGoWhoosh_totalMeleeDamageDone + (amount)
	--end
	

	if sourceGUID == playerGUID and (subevent == "SPELL_DAMAGE" or subevent == "SPELL_AURA_APPLIED") and string.match(buffName, "Windfury Attack") then
		--print(timestamp)
		--print(GLOBAL_WFGoWhoosh_windfuryDamageAmount)
		windfuryTimestamp = timestamp
		if recentlyFired == false then
			local rando = math.random(1,23)
			--local rando = 9
			if (rando == 1) then
				PlaySoundFile("Interface\\AddOns\\WFGoWhoosh\\TFWasThat.wav")
			elseif (rando == 2) then
				PlaySoundFile("Interface\\AddOns\\WFGoWhoosh\\WhatWasThat.wav")
			elseif (rando == 3) then
				PlaySoundFile("Interface\\AddOns\\WFGoWhoosh\\Purr.wav")
			elseif (rando == 4) then
				PlaySoundFile("Interface\\AddOns\\WFGoWhoosh\\KillyKilly.wav")
			elseif (rando == 5) then
				PlaySoundFile("Interface\\AddOns\\WFGoWhoosh\\DontLet.wav")
			elseif (rando == 6) then
				PlaySoundFile("Interface\\AddOns\\WFGoWhoosh\\JustDoIt.wav")
			elseif (rando == 7) then
				PlaySoundFile("Interface\\AddOns\\WFGoWhoosh\\Thunderclap.wav")
			elseif (rando == 8) then
				PlaySoundFile("Interface\\AddOns\\WFGoWhoosh\\AnotherOne.wav")
			elseif (rando == 9) then
				PlaySoundFile("Interface\\AddOns\\WFGoWhoosh\\Sapata.wav")
			elseif (rando == 10) then
				PlaySoundFile("Interface\\AddOns\\WFGoWhoosh\\Airhorn.wav")
			elseif (rando == 11) then
				PlaySoundFile("Interface\\AddOns\\WFGoWhoosh\\DoesHeLook.wav")
			elseif (rando == 12) then
				PlaySoundFile("Interface\\AddOns\\WFGoWhoosh\\Mommas.wav")
			elseif (rando == 13) then
				PlaySoundFile("Interface\\AddOns\\WFGoWhoosh\\WTFBoom.wav")
			elseif (rando == 14) then
				PlaySoundFile("Interface\\AddOns\\WFGoWhoosh\\1whoosh.wav")
			elseif (rando == 15) then
				PlaySoundFile("Interface\\AddOns\\WFGoWhoosh\\staypositive.wav")
			elseif (rando == 16) then
				PlaySoundFile("Interface\\AddOns\\WFGoWhoosh\\1056whoosh.wav")
			elseif (rando == 17) then
				PlaySoundFile("Interface\\AddOns\\WFGoWhoosh\\NotMyRealDad.wav")
			elseif (rando == 18) then
				PlaySoundFile("Interface\\AddOns\\WFGoWhoosh\\BigBadWolf.wav")			
			elseif (rando == 19) then
				PlaySoundFile("Interface\\AddOns\\WFGoWhoosh\\FatherCigarettes.wav")
			elseif (rando == 20) then
				PlaySoundFile("Interface\\AddOns\\WFGoWhoosh\\WHAT.wav")			
			elseif (rando == 21) then
				PlaySoundFile("Interface\\AddOns\\WFGoWhoosh\\YaYeet.wav")
			elseif (rando == 22) then
				PlaySoundFile("Interface\\AddOns\\WFGoWhoosh\\JasonBorne.wav")
			elseif (rando == 23) then
				PlaySoundFile("Interface\\AddOns\\WFGoWhoosh\\PissOffYouRags.wav")
			end
		end
		
		if (recentlyFired) then
			recentlyFired = false;
		else
			recentlyFired = true;
		end
	end
end


local f2 = CreateFrame("Frame", "AutoNameplates")
local addon = {}
--f2:RegisterEvent("PLAYER_REGEN_ENABLED")
--f2:RegisterEvent("PLAYER_REGEN_DISABLED")
f2:SetScript("OnEvent", function(_, event) addon[event]() end)
local postedTimestamp

function addon:PLAYER_REGEN_ENABLED(event, ...)
	if (GLOBAL_WFGoWhoosh_totalMeleeDamageDone > 0) then
		defaultLanguage = GetDefaultLanguage("player")
		percentageAmount = tostring(math.floor(100 * GLOBAL_WFGoWhoosh_windfuryDamageAmount / GLOBAL_WFGoWhoosh_totalMeleeDamageDone))

		wfDamage = "Windfury contributed " .. GLOBAL_WFGoWhoosh_windfuryDamageAmount .. " damage to the enemy!"
		totalDamage = "Total white swing damage done: " .. GLOBAL_WFGoWhoosh_totalMeleeDamageDone
--		totalSpellDamage = "Total spell damage done " .. totalSpellDamageDone .. " to the enemy!"
		percentMessage = "Windfury contributed " .. percentageAmount .. "% of your total melee swing damage"

		local chatPref = GLOBAL_WFGoWhoosh_ChatPreference

		if (GLOBAL_WFGoWhoosh_ChatEnabled) then

			if (IsInGroup() and string.lower(chatPref) == "party") then
				SendChatMessage(wfDamage, "PARTY")
				SendChatMessage(totalDamage, "PARTY")
	--			SendChatMessage(totalSpellDamage, "PARTY")
	--			SendChatMessage(percentMessage, "PARTY")
			else
				print(wfDamage)
				print(totalDamage)
	--			print(totalSpellDamage)
	--			print(percentMessage)
			end
		end
	end

	GLOBAL_WFGoWhoosh_windfuryDamageAmount = 0
	GLOBAL_WFGoWhoosh_totalMeleeDamageDone = 0

	f2:UnregisterEvent("PLAYER_REGEN_ENABLED")
end

function addon:PLAYER_REGEN_DISABLED()
	f2:RegisterEvent("PLAYER_REGEN_ENABLED")
end